
/************************************************************************
 function to update the incremental encoder output register
 and to return the counter value
 parameters : channel : logical channel number
								1,2
 returns    : encoder counter value
 comment    : position counter register is read and returned
			 as a variable of type long
				  (function derived from original dSPACE function
		ds1102_inc from DS1102 software environment)

	Lotfi BAGHLI			  rev 31/07/1996
************************************************************************/

inline long read_inc(long channel)
{
  volatile long *ioctl = (long *) 0x00020000;
  volatile long *pcr   = (long *) 0x00024000 + channel - 1;

	/* transfere le contenu actuel de pos counter -> output reg */
  *ioctl = 0xC0000000;                       /* update output register */

  return ((unsigned long) *pcr);
}


/************************************************************************
* function to pass phase voltages to TMS320P14 slave DSP		*
* parameters : ua, ub, uc  : phase voltages 				*
* condition  : The communication and PWM signal generation code		*
*	       (see function load_slave in file ACPWM.C) must be	*
*	       active on the TMS320P14 slave-DSP			*

	Lotfi BAGHLI			  rev 31/07/1996
	sans disable global interrupt !
************************************************************************/

inline void ds1102_p14_phase_voltages(long ua, long ub, long uc)
{
  volatile long *DSPC  = (long*) (0x00021000);
  volatile long *ioctl = (long*) (0x00020000);

  *DSPC = 0x80000000 | (ua & 0x0000FFFF);
  while (~(*ioctl) & 0x00010000);                   /* wait for DSPRDY */

  *DSPC = ((ub & 0x0000FFFF) << 16) | (uc & 0x0000FFFF);
  while (~(*ioctl) & 0x00010000);                   /* wait for DSPRDY */
}
