/*
	Constantes et variables

	Machine Grise SEW-USOCOM 14/03/2003
	reconfiguration complte Pour DS1102 et nouveau onduleur
	light version Lotfi BAGHLI			  rev 12/12/2006
*/
                                            
/* Machine (une partie des donnes) */
	double Rsmod=2.86;
#define sigma 0.034604
#define Ls 0.39933
#define Lr 0.39933
#define M 0.39236
#define Trconst  0.32601
#define P	1

/* constantes */
#define PI			3.14159265358979323846
#define TWOPI		6.283185307179586
#define E_2			300.0				/* tension du pont / 2 */
#define	BY32767_E_2	109.2233333

/* encoder DS1102 fct +inversion */
#define POStoRD_S	-1.498028113e-3		/* Te=1 ms */
#define POStoRD		-1.498028113e-6


/* PWM  10 us fix par .obj p14 */

#define DT 2.0e-4						/* boucle  200 us , mais MLI  100 us */
#define DS_IReg 2						/* down sampling de la reg Idq % MLI  !DS1104! */
#define DS_WReg 5						/* down sampling de la reg vitesse % Reg Idq */
#define DS_PReg 2                /* down sampling de la reg position % Reg W */
double exec_time;                                         /* execution time */


double IdsrefBase=1.4;
#define WmBaseB	209.44	/* 2000 tr/mn */
#define WmBase		230.38 	/* 2200 tr/mn */
double Kdeflux=293; 		/* 293 SEW */

#define Idsref1 1.4
#define Idsref2 1
#define Idsref3 0.5

#define Wmlim1b 209.44
#define Wmlim1 230.38
#define Wmlim2b  418.88
#define Wmlim2  439.82


/*---------------------------------------------------------------------------*/
/* les courants */
double Ias=0.0;
double Ibs=0.0;
double Ialphas, Ibetas;

/* cos sin */
double c, s;
double e;

/* Les tensions */
double Vas=0.0;
double Vbs=0.0;
double Vcs=0.0;
double	Valphas, Vbetas,
				Vdsref, Vqsref;

/* Les fem s */
double Ealphas, Ebetas;

double th=0.0;                                          	/* theta s */

/* regulateurs PI courant */
double Kpq=20;
double Kiq=0.8;
/* #define VqsrefMax	211.0 est varible */
double 	xeq=0.0;
double Vqsref = 0.0;
double VqsrefMax=211.0;

double Kpd=20;
double Kid=0.8;
#define VdsrefMax	211.0
double 	xed=0.0;
double Vdsref = 0.0;

double	Ids, Iqs, e;

/* regulateur IP antiwindup vitesse */
double 	KpW=1.0;
double 	KiW=0.03;
double 	KTiW=1.0;
#define IqsrefMax	6.0
#define xeWMax		1000.0

double	xeW=0.0;
double	WmMesure=0.0;
double	Wm=0.0;
double	OldSortie=0.0;
double	OldSortieSat=0.0;
double	Wmref=0.0;
double	absWm;

/* encoder */
double FIR_Wm[5];
long	inc_k;
long	inc_kOld=0;

/* regulateur P position */
double	mpos=0.0;			/* position rd */
double	mposref=0.0;	/* position reference rd */
double KpP=17.5;
#define WmrefMax	209.44

/* ceux du decouplage */
double Wsl, Ws;
double 	Phidr=0.0;

double	Deltath;

/* Ids */
double	IdsErr, IdsErr_hN, IdsErr_hZ, IdsErr_hP,		/* erreur */
			IdsOldE,
			IdsdErr, IdsdErr_hN, IdsdErr_hZ, IdsdErr_hP,	/* derivee erreur */
			IdsdU, IdsdU_hN, IdsdU_hZ, IdsdU_hP;			/* sortie */
/* Facteurs ( Gain ) des fonctions d'appartenances floues ... */
double 	IdsFErr=0.5;		/* 0.5 */
double 	IdsFdErr=2.0;		/* 2.0 */
double 	IdsFdU=5.0;		/* 15.0; */


/* Iqs */
double	IqsErr, IqsErr_hN, IqsErr_hZ, IqsErr_hP,		/* erreur */
			IqsOldE,
			IqsdErr, IqsdErr_hN, IqsdErr_hZ, IqsdErr_hP,	/* derivee erreur */
			IqsdU, IqsdU_hN, IqsdU_hZ, IqsdU_hP;			/* sortie */
/* Facteurs ( Gain ) des fonctions d'appartenances floues ... */
double 	IqsFErr=0.5;		/* 0.5 */
double 	IqsFdErr=2.0;		/* 2.0 */
double 	IqsFdU=5.0;		/* 15.0; */


/* vitesse */
double	WErr, WErr_hN, WErr_hZ, WErr_hP,		/* erreur */

			WdErr, WdErr_hN, WdErr_hZ, WdErr_hP,	/* derivee erreur */
			WdU, WdU_hN, WdU_hZ, WdU_hP;			/* sortie */

/* init la zone d'echange avec host */
/* changement ---Pic des fonctions d'appartenances floues ...
					en Facteurs ( Gain ) */
double 	WFErr=0.025;
double 	WFdErr=0.5;
double 	WFdU=7.0;	/* nouveau banc */

/* variables for execution time profiling */
unsigned int countCurrent=0;				/* Boucle de courant = 2 * 0.1 ms =0.2 ms */
unsigned int countSpeed=0;					/* Boucle de vitesse = 5 * 0.2 ms =1 ms */
unsigned int countPos=0;						/* Boucle de position = 2 * 1 ms */

/* Flags du type de controle */
int CurrentControllerType=0;	/* 0 = PI,  1= Fuzzy */
int SpeedControllerType=0;		/* 0 = IP,  1= Fuzzy  */

int	VectorControlFlag = 0;		/* Vector control by default */
															/* 0 = V_f	,		1= Vector control , 2 V/f continu*/
int	SpeedControlFlag=1;				/* init a Vit/Pos ctrl au lieu de cmde en courant  */
															/* 0 = cmde en Courant, 1= Regul Vitesse/Position */
int PosControlFlag=0;					/* init a Speed ctrl */
															/* 0 = Regul Vitesse,   1= Regul Position */

/* Variables Indirect stator ctrl */
	double dIds=0.0;
	double dIqs=0.0;
	double IdsOld=0.0;
	double IqsOld=0.0;
	double Phids=0.0;
	double Wsl_Stator=0.0;
	double Idqs=0.0;

/* on veut pouvoir tout changer */
int Deflux_Type=0;	/* pas de defluxage */
/* Type de defluxage
	0 : pas de defluxage
	1 : par palier
	2 : en continu */

/* on veut pouvoir tout changer */
double 	Tr=Trconst;
double 	Idsref; /* initialisable en bas  1.4 A */
double Iqsref=0.0;

/* V_f control */
double	Vsref = 0.0;
double	Wsref = 0.0;
//V/f	lis par K_V_f 
double K_V_f=5.4;   // 6.22254; // 220*r2/50 V/Hz et 3 de maniere exp
											//  VDC=600 V, Kvf=8.48 donne  200 rd/s (31.8 Hz) Vds=270V Ias crete=3.9 A
double fs=0.0;

double e,de,sde,
	du, WsdErr;
double 	OldWE=0.0;
double 	OldsWE=0.0;

// test crenaux Iqsref
volatile int 	TestIqs=0;
volatile int 	TestIqsDeb=1;
volatile int 	Testinc=0;
volatile double 	EchIqsref=2.0;
volatile int 	Testinclim1=100;
volatile int 	Testinclim2=200;
// test crenaux Wmref
volatile int 	TestWm=0;
volatile double 	EchWmref=20.0;
volatile int 	TestWminc=0;
volatile int 	Testinclim=1000;
// test rampe Wmref
volatile int 	RampeWm=0;
volatile int 	RampePhase=1;
volatile int 	Testinclimph2=300;

int	InhibFlag=1;	// initialement, onduleur coup

void initVar()
{
	Idsref=IdsrefBase; /* 1.4 A */
}
