/*
	Commande Vectorielle Indirecte par Orientation du Flux Rotorique
	------------  reconfiguration complte Pour DS1102  ------------
	avec regulateur flou de vitesse et de Courant
	+ multi ctrl type ( class / flou / neuro )

	avec regul de position Treg=10*1ms, Proportionel
	avec stator ind flux orientation
	et defluxage progressif

	Grande Machine
	Lotfi BAGHLI			  19/06/1996	rev 27/03/1997
	rev 04/06/1997		3 type de defluxage, et cmde en courant
	rev 11/06/1997		V/f et pleine onde (pseudo)
	rev 13/11/1997		change K const_reg
	rev ->01/12/97		Direct Stator Field Control...
	rev 11/12/1997		Idqs compensation + Stator flux regul
							 + Ind Stat/Dir Stat automatic switch at low speed

Light pour moins de temps de calcul mais tjrs stator direct rev 17/04/1998
	REV 9/7/2002 INHIB FUNCTION

	reconfiguration complte Pour DS1102 et nouveau onduleur
	no C31 timer used, better time task sharing ;-)
	Lotfi BAGHLI			  rev 14/03/2003
	light version Lotfi BAGHLI			  rev 12/12/2006

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include <brtenv.h>                           /* basic real-time environment */
#include <math.h>		/* sin cos */
#include "ctrl.h"		/* Declaration des fonctions + macros + includes 
												Declaration de variables + initialisation*/

/*---------------------------------------------------------------------------*/
/* pour l'interruption */
#define ioctl   ((volatile long *) 0x20000)
#define dspeoi0 0x00100000
#define iomsk   0x00008000
#define int0vec ((void (* volatile *)()) 0x0001)

unsigned long count0;                             /* timer0 time count */

void c_int01()					/* routine de gestion de int0 */
{
	/*	ds1102_da(2, 0.5);	 signal 2 ! out */
  ds1102_ad_start();	  	/* capture les courants */
	RTLIB_TIC_START();                              /* start time measurement */
	/* 	ds1102_da(2, 0.0);	signal 2 ! out */
 *ioctl = (*ioctl & iomsk) | dspeoi0;  /* clear int0 request */
 *ioctl;                               /* sync to posted write               */
	asm ("	ANDN	01H,IF");              /* clear int0 flag  */
	switch(countCurrent)
		{
		case 0	:	RegulI_Control();
							break;
		case 1	:	Regul_Vitesse();
						  host_service(1, 0);				/* Data Acquisition service */
							break;
		}
	if (++countCurrent==DS_IReg)	countCurrent=0;
  exec_time = RTLIB_TIC_READ(); /*  calculate execution time */
}


/*---------------------------------------------------------------------------*/
void main(void)
{
  init();                                /* initialize hardware system */
	initVar();			// initialise les variables locales

	/* download standard communication and PWM code to P14 slave processor */
	load_slave();
	ds1102_inc_clear_counter( 1); 			/* clear incremental encoder 1 */

	msg_info_set(MSG_SM_RTLIB, 0, "System started from Lotfi.");
  RTLIB_TIC_INIT();                 /* enable execution time measurement */

/* -----------   Installation de l'interruption  ------------ */
	*int0vec = c_int01;                   /* install interrupt vector           */
	asm ("	OR	01H,IE");               /* enable int0 interrupts             */
	global_enable();                      /* enable interrupts                  */

  /* Background tasks */
  while(msg_last_error_number() == DS1102_NO_ERROR)            /* loop */
		{
    RTLIB_BACKGROUND_SERVICE();                        /* background service */
		}
  /* Reset PWM inverter en cas d'erreur */
	ds1102_p14_phase_voltages( (long) 0, (long) 0, (long) 0 ); /* erreur, on sort */
}
